;;; this would go into slime.el
(defun slime-eval-custom-expand (expander exp-str package buffer-name)
  (lexical-let ((package package)
                (buffer-name buffer-name))
    (slime-eval-async
     (list 'swank:eval-and-grab-output (format "(%s %s)" expander exp-str))
     (lambda (expansion)
       (slime-with-output-to-temp-buffer
           ;; reusep for preserving `undo' functionality.
           (buffer-name :mode lisp-mode :reusep t) package
         (slime-mode)
         (erase-buffer)
         (insert (second expansion))
         (font-lock-fontify-buffer)))
     package)))

(defun slime-add-custom-expander (key expander buffer-name)
  (slime-define-key key (lexical-let ((expander expander)
                                      (buffer-name buffer-name))
                          (lambda (&rest _)
                            (interactive "P")
                            (slime-eval-custom-expand expander
                                                      (first (slime-sexp-at-point-for-macroexpansion))
                                                      (slime-current-package)
                                                      buffer-name)))
                    :prefixed t :inferior t))

;;; This stuff would go into .emacs or similar
(slime-add-custom-expander "j" 'js:js "*ParenScript generated Javascript*")
